classdef SCDalgo_test < matlab.unittest.TestCase
  
  properties (Abstract=true)
    algoobj % SCD algo obj name - abstract allows modification by sub-class
  end
  
  methods (TestClassSetup)
    function setup_conf(testCase)
      testCase.assertWarningFree(@() SCDconf_setSIMconf);
    end
    
    function setup_algo(testCase)
      testCase.assertInstanceOf(testCase.algoobj,'SCDclass_algo');
    end  
  end
  
  methods (Test)
    function test_initdd(testCase)
      testCase.algoobj.initdd; % init data dictionary
    end
    
    function test_setup(testCase)
      testCase.algoobj.setup; % setup tunable parameters
    end
    
    function test_compile(testCase)
      testCase.algoobj.compile; % update model (Ctrl-D) Simulink
    end
    
    function test_test_harness(testCase)
      testCase.algoobj.test_harness;
    end
  end
  
end